// Primary board code, or as I call it, the brain code. This program is the first step in my plan to use I2C in my final project.
// Here, I plan to simulate how the gatekeeper board will work with the main board. The brain board will receive information from the
// gatekeepers and print it in the serial monitor. This is a very basic and skeletal representation of how the final code will look.

#include <Wire.h>

void setup() {
   Serial.begin(115200);
   Wire.begin();
}

uint8_t address, count;

void loop() {
   count = 0;
   Serial.println("start scan ...");
   for (address = 1; address < 127; address++) {
      Wire.beginTransmission(address);
      if (Wire.endTransmission() == 0) {
         count += 1;
         Serial.print("   found ");
         Serial.print(address, DEC);
         Serial.print(" (0x");
         Serial.print(address, HEX);
         Serial.println(")");

         
         Wire.requestFrom(address, 1);
         while (Wire.available()) {
            char receivedChar = Wire.read();
            Serial.print("   Received data: ");
            Serial.println(receivedChar);
         }
      }
   }
   if (count == 0)
      Serial.println("   no devices found");
   delay(1000);
}


